﻿package  
{
	import net.flashpunk.World;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.utils.Draw;
	import flash.desktop.Clipboard;
	import flash.desktop.ClipboardFormats;
	
	public class l_Game extends World
	{
		var pullstartx:Number = 0;
		var pullstarty:Number = 0;

		public function l_Game() 
		{	
			FP.screen.color = 0xFFFFFF;
			add(new e_Wall(0,500,800,100,false));
			add(new e_Wall(650,0,150,100,false));
			add(new e_Wall(0,0,150,500,false));

			Input.define("Copy", Key.A, Key.LEFT);
			Input.define("Reset", Key.D, Key.RIGHT);
			Input.define("Delete", Key.S, Key.DOWN);
		}
		
		public override function update():void
		{
			super.update();
			if (Input.pressed("Copy")) copyText();
			if (Input.pressed("Reset")) {
				var list:Array = [];
				getClass(e_Wall, list);
				for each (var w:e_Wall in list) {
					if (w.b) FP.world.remove(w);
				}
			}
			if (Input.pressed("Delete")) {
				var list:Array = [];
				getClass(e_Wall, list);
				for each (var w:e_Wall in list) {
					if (w.x < Input.mouseX && w.y < Input.mouseY && w.x+w.w > Input.mouseX && w.y+w.h > Input.mouseY && w.b) FP.world.remove(w);
				}
			}
			if (Input.mousePressed) {
				pullstartx=Math.round(Input.mouseX/25)*25;
				pullstarty=Math.round(Input.mouseY/25)*25;
			}
			if (Input.mouseReleased) {
				var pullendx:Number = Math.round(Input.mouseX/25)*25;
				var pullendy:Number = Math.round(Input.mouseY/25)*25;
				var temp:Number;
				if (pullendx<pullstartx) {
					temp = pullstartx;
					pullstartx = pullendx;
					pullendx = temp;
				}
				if (pullendy<pullstarty) {
					temp = pullstarty;
					pullstarty = pullendy;
					pullendy = temp;
				}
				add(new e_Wall(pullstartx,pullstarty,pullendx-pullstartx,pullendy-pullstarty,true));
			}
		}

		override public function render():void 
		{
			super.render();
			for (var i:Number=50; i<600; i+=50) {
				Draw.line(0,i,800,i,0x999999);
			}
			for (i=50; i<800; i+=50) {
				Draw.line(i,0,i,600,0x999999);
			}
			for (i=25; i<600; i+=50) {
				Draw.line(0,i,800,i,0xCCCCCC);
			}
			for (i=25; i<800; i+=50) {
				Draw.line(i,0,i,600,0xCCCCCC);
			}
			if (Input.mouseDown) {
				Draw.rect(pullstartx,pullstarty,Math.round(Input.mouseX/25)*25-pullstartx,Math.round(Input.mouseY/25)*25-pullstarty,0x0000FF);
			}
		}

		function copyText() {
			var clipboard:String = " else if (o==2) {\n";
			var list:Array = [];
			getClass(e_Wall, list);
			for each (var w:e_Wall in list) {
				if (w.b) clipboard += "\t\t\t\t\t\t\tadd(new e_Wall(screen.x*800+"+w.x+",screen.y*600+"+w.y+","+w.w+","+w.h+",true));\n";
			}
			clipboard += "\t\t\t\t\t\t}";
			Clipboard.generalClipboard.clear();
			Clipboard.generalClipboard.setData(ClipboardFormats.TEXT_FORMAT, clipboard, false);
		}
	}
}
