﻿package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Draw;
		
	public class e_Particle extends Entity
	{
		public var xspeed:Number = 0;
		public var yspeed:Number = 0;
		public var color:uint = 0x000000;
		public var alph:Number = 1;
		public var fospeed:Number = 0.05;
		public var size:Number;

		public function e_Particle(xpos:Number,ypos:Number,xsp:Number,ysp:Number,col:uint,s:Number=2) 
		{
			type = "particle";
			layer = -1;

			x=xpos;
			y=ypos;
			xspeed=xsp;
			yspeed=ysp;
			color=col;
			size=s;
			if (size==15) {
				alph=0.5;
				fospeed=0.07;
			}
		}
		
		override public function update():void 
		{
			x+=xspeed;
			y+=yspeed;

			alph-=fospeed;

			if (alph <= 0)
				FP.world.remove(this);
		}

		override public function render():void 
		{
			Draw.circlePlus(x,y,size,color,alph);
		}
	}
}
