﻿package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Draw;
	import flash.geom.Point;

	public class e_Score extends Entity
	{
		public var text:Text;
		public var visited:Array;
		public var deathscreen:Point;
		public var lastscreen:Point;
		public var f:Number;

		public function e_Score(sc:Number,xp:Number,yp:Number,visit:Array,dead:Point,last:Point) 
		{
			x=xp;
			y=yp;
			layer = -50;

			Text.size = 48;
			text = new Text("You survived for "+sc+"km",0,0);
			text.color = 0x000000;
			graphic = text;
			visited = visit;
			deathscreen = dead;
			lastscreen = last;

			if (lastscreen.x+lastscreen.y>deathscreen.x+deathscreen.y) {
				var mapw:Number = lastscreen.x*800;
				var maph:Number = lastscreen.y*600;
			} else {
				var mapw:Number = deathscreen.x*800;
				var maph:Number = deathscreen.y*600;
			}
			var wf:Number = 600/mapw;
			var hf:Number = 400/maph;
			if (wf<hf) f=wf;
			else f=hf;
		}

		override public function update():void 
		{
			
		}

		override public function render():void
		{
			super.render();
			var col:uint = 0xFFFFFF;
			for each (var p:Point in visited) {
				if (p.equals(deathscreen))	Draw.rect(p.x*800*f+75+FP.camera.x,p.y*600*f+100+FP.camera.y,800*f,600*f,0x0000CC);
				else						Draw.rect(p.x*800*f+75+FP.camera.x,p.y*600*f+100+FP.camera.y,800*f,600*f,col);
				if (col==0xFFFFFF) col=0x000000;
				else col=0xFFFFFF;
			}
		}
	}
}
